set.seed(0)

## Monte-Carlo ST:
##
S0 = 105
rets = rnorm(20000, mean=log(110/S0), sd=0.01)
ST = S0*exp(rets)

## Compute samples of the loss:
##
VT = 100*pmax(0, ST - 108) - 100*pmax(0, ST - 112) ## minus a constant 
loss = -VT

alpha = 0.05
VaR = quantile(loss, alpha)
ES = mean(loss[loss<VaR])

## Do some plots:
##
par(mfrow=c(1, 2))
hist(ST) ## these look more reasonable
abline(v=c(108, 112), col='red')

hist(loss)
par(mfrow=c(2, 2))

print(sprintf('VaR= %f; ES= %f', -VaR, -ES)) ## <- VaR is normally reported as a positive number

