#
# Written by:
# -- 
# John L. Weatherwax                2009-04-21
# 
# email: wax@alum.mit.edu
# 
# Please send comments and especially bug reports to the
# above email address.
# 
#-----

set.seed(0)

X = seq(1,10,length.out=30)
X2 = X^2
cor(X,X2)

m_x_on_x2 = lm( X ~ X2 )
sm_x_on_x2 = summary(m_x_on_x2)
RX = sm_x_on_x2$r.squared # R^2 for X ~ X2
VIF_X = 1/(1-RX) 

# The VIF is symmetric in the two variable case ... here we show this numerically 
m_x2_on_x = lm( X2 ~ X )
sm_x2_on_x = summary(m_x2_on_x)
RX2 = sm_x2_on_x$r.squared # R^2 for X2 ~ X
VIF_X2 = 1/(1-RX2) 

V = X - mean(X)
V2 = V^2
cor(V,V2)

m_v_on_v2 = lm( V ~ V2 )
sm_v_on_v2 = summary(m_v_on_v2)
RV = sm_v_on_v2$r.squared
VIF_V = 1/(1-RV^2) 

print( sprintf("cor(X,X^2)= %5.3f", cor(X,X2) ) )
print( sprintf("cor(V,V^2)= %5.3f", cor(V,V2) ) )
print( sprintf("VIF for X and X^2= %5.3f", VIF_X) )
print( sprintf("VIF for (X-barX) and (X-barX)^2= %5.3f", VIF_V) )


