#
# Written by:
# -- 
# John L. Weatherwax                2009-04-21
# 
# email: wax@alum.mit.edu
# 
# Please send comments and especially bug reports to the
# above email address.
# 
#-----

set.seed(0)

n = 66
M = 5 # the largest number of predictors
total_SS = 48
residual_error_SS = c(12.0, 10.2, 10.0)
ps = c( 3, 4, 5 )

R2 = 1 - residual_error_SS / total_SS 

Adjusted_R2 = 1 - ( residual_error_SS / (n-ps-1) ) / ( total_SS / (n-1) ) 

sigma_epsilon_M2 = residual_error_SS[3] / ( n - 1 - M ) 
Cp = residual_error_SS / sigma_epsilon_M2 - n + 2 * ( ps + 1 ) 

R = rbind( R2, Adjusted_R2, Cp )
colnames(R) = c('p=3', 'p=4', 'p=5')
print(R)
